
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use ieee.numeric_std.all;
-- All structs defined in C code

package c_structs_pkg is

  type byte_array_t is array (natural range <>) of unsigned(7 downto 0);
  function to_byte_array(s : string) return byte_array_t;
  type uint24_t_1 is array(0 to 0) of unsigned(23 downto 0);
constant uint24_t_1_SLV_LEN : integer := 24 * 1;

      function uint24_t_1_to_slv(data : uint24_t_1) return std_logic_vector;

      function slv_to_uint24_t_1(data : std_logic_vector) return uint24_t_1;
type uint25_t_1 is array(0 to 0) of unsigned(24 downto 0);
constant uint25_t_1_SLV_LEN : integer := 25 * 1;

      function uint25_t_1_to_slv(data : uint25_t_1) return std_logic_vector;

      function slv_to_uint25_t_1(data : std_logic_vector) return uint25_t_1;

  type uint24_t_array_1_t is record
  
    data : uint24_t_1;
  end record;
  
  constant uint24_t_array_1_t_NULL : uint24_t_array_1_t := (
  
    data => (others => (others => '0'))
  );
  
  constant uint24_t_array_1_t_SLV_LEN : integer := (
  uint24_t_1_SLV_LEN
  );
  
  function uint24_t_array_1_t_to_slv(data : uint24_t_array_1_t) return std_logic_vector;

  function slv_to_uint24_t_array_1_t(data : std_logic_vector) return uint24_t_array_1_t;

  type uint25_t_array_1_t is record
  
    data : uint25_t_1;
  end record;
  
  constant uint25_t_array_1_t_NULL : uint25_t_array_1_t := (
  
    data => (others => (others => '0'))
  );
  
  constant uint25_t_array_1_t_SLV_LEN : integer := (
  uint25_t_1_SLV_LEN
  );
  
  function uint25_t_array_1_t_to_slv(data : uint25_t_array_1_t) return std_logic_vector;

  function slv_to_uint25_t_array_1_t(data : std_logic_vector) return uint25_t_array_1_t;

end c_structs_pkg;
package body c_structs_pkg is

  function to_byte_array(s : string) return byte_array_t is
    variable rv : byte_array_t(0 to s'length-1);
  begin
    for i in 0 to s'length-1 loop
        -- i+1 since strings start at index 1
        rv(i) := to_unsigned(character'pos(s(i+1)), 8);
    end loop;
    return rv;
  end function;
  
      function uint24_t_1_to_slv(data : uint24_t_1) return std_logic_vector is
        variable rv : std_logic_vector(uint24_t_1_SLV_LEN-1 downto 0);
        variable pos : integer := 0;
      begin
    
            rv((pos+24)-1 downto pos) := std_logic_vector(data(0));
            pos := pos + 24;
    
          return rv;
      end function;
    
      function slv_to_uint24_t_1(data : std_logic_vector) return uint24_t_1 is
        variable rv : uint24_t_1;
        variable elem_slv : std_logic_vector(24-1 downto 0);
        variable pos : integer := 0;
      begin
    
            elem_slv := data((pos+24)-1 downto pos);
            rv(0) := unsigned(elem_slv);
            pos := pos + 24;
    
          return rv;
      end function;
    
      function uint25_t_1_to_slv(data : uint25_t_1) return std_logic_vector is
        variable rv : std_logic_vector(uint25_t_1_SLV_LEN-1 downto 0);
        variable pos : integer := 0;
      begin
    
            rv((pos+25)-1 downto pos) := std_logic_vector(data(0));
            pos := pos + 25;
    
          return rv;
      end function;
    
      function slv_to_uint25_t_1(data : std_logic_vector) return uint25_t_1 is
        variable rv : uint25_t_1;
        variable elem_slv : std_logic_vector(25-1 downto 0);
        variable pos : integer := 0;
      begin
    
            elem_slv := data((pos+25)-1 downto pos);
            rv(0) := unsigned(elem_slv);
            pos := pos + 25;
    
          return rv;
      end function;
    
  function uint24_t_array_1_t_to_slv(data : uint24_t_array_1_t) return std_logic_vector is
    variable rv : std_logic_vector(uint24_t_array_1_t_SLV_LEN-1 downto 0);
    variable pos : integer := 0;
  begin

        rv((pos+uint24_t_1_SLV_LEN)-1 downto pos) := uint24_t_1_to_slv(data.data);
        pos := pos + uint24_t_1_SLV_LEN;

      return rv;
  end function;

  function slv_to_uint24_t_array_1_t(data : std_logic_vector) return uint24_t_array_1_t is
    variable rv : uint24_t_array_1_t;
    variable pos : integer := 0;
    variable data_slv : std_logic_vector(uint24_t_1_SLV_LEN-1 downto 0);
  begin

        data_slv := data((pos+uint24_t_1_SLV_LEN)-1 downto pos);
        rv.data := slv_to_uint24_t_1(data_slv);
        pos := pos + uint24_t_1_SLV_LEN;

      return rv;
  end function;

  function uint25_t_array_1_t_to_slv(data : uint25_t_array_1_t) return std_logic_vector is
    variable rv : std_logic_vector(uint25_t_array_1_t_SLV_LEN-1 downto 0);
    variable pos : integer := 0;
  begin

        rv((pos+uint25_t_1_SLV_LEN)-1 downto pos) := uint25_t_1_to_slv(data.data);
        pos := pos + uint25_t_1_SLV_LEN;

      return rv;
  end function;

  function slv_to_uint25_t_array_1_t(data : std_logic_vector) return uint25_t_array_1_t is
    variable rv : uint25_t_array_1_t;
    variable pos : integer := 0;
    variable data_slv : std_logic_vector(uint25_t_1_SLV_LEN-1 downto 0);
  begin

        data_slv := data((pos+uint25_t_1_SLV_LEN)-1 downto pos);
        rv.data := slv_to_uint25_t_1(data_slv);
        pos := pos + uint25_t_1_SLV_LEN;

      return rv;
  end function;
end package body c_structs_pkg;
