
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use ieee.numeric_std.all;
use work.c_structs_pkg.all; -- User types
-- Clock crossings
package clk_cross_t_pkg is

  type x_clk_cross_to_module_t is record
         x_DEBUG_READ_return_output : uint24_t_array_1_t;

  end record;

  type y_clk_cross_to_module_t is record
         y_DEBUG_READ_return_output : uint24_t_array_1_t;

  end record;

  type result_DEBUG_OUTPUT_MAIN_clk_cross_to_module_t is record
         result_DEBUG_READ_return_output : uint25_t_array_1_t;

  end record;

  type test_bench_clk_cross_to_module_t is record
    
    x_u24add_c_l34_c17_6950 : x_clk_cross_to_module_t;
    y_u24add_c_l34_c22_71c8 : y_clk_cross_to_module_t;
  end record;

  type x_DEBUG_INPUT_MAIN_module_to_clk_cross_t is record
         x_DEBUG_WRITE_CLOCK_ENABLE : unsigned(0 downto 0);
     x_DEBUG_WRITE_in_data : uint24_t_array_1_t;

  end record;
  

  type y_DEBUG_INPUT_MAIN_module_to_clk_cross_t is record
         y_DEBUG_WRITE_CLOCK_ENABLE : unsigned(0 downto 0);
     y_DEBUG_WRITE_in_data : uint24_t_array_1_t;

  end record;
  

  type result_module_to_clk_cross_t is record
         result_DEBUG_WRITE_CLOCK_ENABLE : unsigned(0 downto 0);
     result_DEBUG_WRITE_in_data : uint25_t_array_1_t;

  end record;
  

  type test_bench_module_to_clk_cross_t is record
    
    result_u24add_c_l34_c3_4e89 : result_module_to_clk_cross_t;
  end record;
  
type clk_cross_to_module_t is record
    result_DEBUG_OUTPUT_MAIN : result_DEBUG_OUTPUT_MAIN_clk_cross_to_module_t;
    test_bench : test_bench_clk_cross_to_module_t;
  end record;
  
  type module_to_clk_cross_t is record
    x_DEBUG_INPUT_MAIN : x_DEBUG_INPUT_MAIN_module_to_clk_cross_t;
    y_DEBUG_INPUT_MAIN : y_DEBUG_INPUT_MAIN_module_to_clk_cross_t;
    test_bench : test_bench_module_to_clk_cross_t;
  end record;
  
  
end clk_cross_t_pkg;
