-- Timing params:
--   Fixed?: False
--   Pipeline Slices: []
--   Input regs?: False
--   Output regs?: False
library std;
use std.textio.all;
library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use ieee.float_pkg.all;
use work.c_structs_pkg.all;
use work.clk_cross_t_pkg.all;
-- Submodules: 2
entity result_0CLK_23f04728 is
port(
 CLOCK_ENABLE : in unsigned(0 downto 0);
 module_to_clk_cross : out result_module_to_clk_cross_t;
 val : in unsigned(24 downto 0));
end result_0CLK_23f04728;
architecture arch of result_0CLK_23f04728 is
-- Types and such
-- Declarations
constant PIPELINE_LATENCY : integer := 0;

-- One struct to represent this modules variables
type variables_t is record
 -- All of the wires in function
 CLOCK_ENABLE : unsigned(0 downto 0);
 CONST_REF_RD_uint25_t_array_1_t_uint25_t_array_1_t_5b41_u24add_c_l26_c342_81e6_return_output : uint25_t_array_1_t;
 result_DEBUG_WRITE_u24add_c_l26_c323_f28d_CLOCK_ENABLE : unsigned(0 downto 0);
 result_DEBUG_WRITE_u24add_c_l26_c323_f28d_in_data : uint25_t_array_1_t;
 result_DEBUG_clk_cross_write_array : uint25_t_array_1_t;
 val : unsigned(24 downto 0);
end record;

-- Function to null out variables 
function variables_NULL return variables_t is
 variable rv : variables_t;
  begin
   rv.CLOCK_ENABLE := (others => '0');
 rv.val := (others => '0');
 rv.result_DEBUG_clk_cross_write_array := uint25_t_array_1_t_NULL;
 rv.result_DEBUG_WRITE_u24add_c_l26_c323_f28d_in_data := uint25_t_array_1_t_NULL;
 rv.CONST_REF_RD_uint25_t_array_1_t_uint25_t_array_1_t_5b41_u24add_c_l26_c342_81e6_return_output := uint25_t_array_1_t_NULL;
 rv.result_DEBUG_WRITE_u24add_c_l26_c323_f28d_CLOCK_ENABLE := (others => '0');

    return rv;
  end function;


-- Type for this modules register pipeline
type register_pipeline_t is array(0 to PIPELINE_LATENCY) of variables_t;
  -- Each function instance gets signals
function CONST_REF_RD_uint25_t_array_1_t_uint25_t_array_1_t_5b41( ref_toks_0 : unsigned) return uint25_t_array_1_t is
 
  variable base : uint25_t_array_1_t; 
  variable return_output : uint25_t_array_1_t;
begin
      base.data(0) := ref_toks_0;

      return_output := base;
      return return_output; 

end function;
  

begin

-- SUBMODULE INSTANCES 


 -- Combinatorial process for pipeline stages
process (
 CLOCK_ENABLE,
 -- Inputs
 val)
is 
 -- Read and write variables to do register transfers per clock
 -- from the previous to next stage
 variable read_pipe : variables_t;
 variable write_pipe : variables_t;

  -- This modules self pipeline registers read once per clock
  variable read_self_regs : register_pipeline_t;
  variable write_self_regs : register_pipeline_t;
begin
 -- Default null read_pipe
 -- NO DONT, hides tool problems? read_pipe := variables_NULL;
 -- Loop to construct simultaneous register transfers for each of the pipeline stages
 -- LATENCY=0 is combinational Logic
 for STAGE in 0 to PIPELINE_LATENCY loop
  -- Input to first stage are inputs to function
  if STAGE=0 then
   -- Mux in clock enable
   read_pipe.CLOCK_ENABLE := CLOCK_ENABLE;
   -- Mux in inputs
   read_pipe.val := val;
  else
   -- Default read from previous stage
   read_pipe := read_self_regs(STAGE-1);
  end if;
  -- Default write contents of previous stage
  write_pipe := read_pipe;

   if STAGE = 0 then
   -- SUBMODULE LEVEL 0
   write_pipe.result_DEBUG_WRITE_u24add_c_l26_c323_f28d_CLOCK_ENABLE := write_pipe.CLOCK_ENABLE;
   -- CONST_REF_RD_uint25_t_array_1_t_uint25_t_array_1_t_5b41[u24add_c_l26_c342_81e6] LATENCY=0
   write_pipe.CONST_REF_RD_uint25_t_array_1_t_uint25_t_array_1_t_5b41_u24add_c_l26_c342_81e6_return_output := CONST_REF_RD_uint25_t_array_1_t_uint25_t_array_1_t_5b41(
   write_pipe.val);

   -- SUBMODULE LEVEL 1
   write_pipe.result_DEBUG_WRITE_u24add_c_l26_c323_f28d_in_data := write_pipe.CONST_REF_RD_uint25_t_array_1_t_uint25_t_array_1_t_5b41_u24add_c_l26_c342_81e6_return_output;
   -- result_DEBUG_WRITE[u24add_c_l26_c323_f28d] LATENCY=0
     -- Clock enable
     module_to_clk_cross.result_DEBUG_WRITE_CLOCK_ENABLE <= write_pipe.result_DEBUG_WRITE_u24add_c_l26_c323_f28d_CLOCK_ENABLE;
     -- Inputs
     module_to_clk_cross.result_DEBUG_WRITE_in_data <= write_pipe.result_DEBUG_WRITE_u24add_c_l26_c323_f28d_in_data;

   end if;
  -- Write to stage reg
  write_self_regs(STAGE) := write_pipe;
  -- Some tools dont like if read_pipe is never fully driven, dummy drive
  -- And some tools dont like this dummy? read_pipe := write_pipe;
 end loop;


 -- Drive registers and outputs
end process;

end arch;
