-- Timing params:
--   Fixed?: False
--   Pipeline Slices: []
--   Input regs?: False
--   Output regs?: False
library std;
use std.textio.all;
library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use ieee.float_pkg.all;
use work.c_structs_pkg.all;
use work.clk_cross_t_pkg.all;
-- Submodules: 4
entity test_bench_0CLK_f691aa4a is
port(
 CLOCK_ENABLE : in unsigned(0 downto 0);
 clk_cross_to_module : in test_bench_clk_cross_to_module_t;
 module_to_clk_cross : out test_bench_module_to_clk_cross_t);
end test_bench_0CLK_f691aa4a;
architecture arch of test_bench_0CLK_f691aa4a is
-- Types and such
-- Declarations
constant PIPELINE_LATENCY : integer := 0;

-- One struct to represent this modules variables
type variables_t is record
 -- All of the wires in function
 CLOCK_ENABLE : unsigned(0 downto 0);
 result_u24add_c_l34_c3_4e89_CLOCK_ENABLE : unsigned(0 downto 0);
 result_u24add_c_l34_c3_4e89_val : unsigned(24 downto 0);
 u24add_u24add_c_l34_c10_3def_return_output : unsigned(24 downto 0);
 u24add_u24add_c_l34_c10_3def_x : unsigned(23 downto 0);
 u24add_u24add_c_l34_c10_3def_y : unsigned(23 downto 0);
 x_u24add_c_l34_c17_6950_return_output : unsigned(23 downto 0);
 y_u24add_c_l34_c22_71c8_return_output : unsigned(23 downto 0);
end record;

-- Function to null out variables 
function variables_NULL return variables_t is
 variable rv : variables_t;
  begin
   rv.CLOCK_ENABLE := (others => '0');
 rv.result_u24add_c_l34_c3_4e89_val := (others => '0');
 rv.u24add_u24add_c_l34_c10_3def_x := (others => '0');
 rv.u24add_u24add_c_l34_c10_3def_y := (others => '0');
 rv.x_u24add_c_l34_c17_6950_return_output := (others => '0');
 rv.y_u24add_c_l34_c22_71c8_return_output := (others => '0');
 rv.u24add_u24add_c_l34_c10_3def_return_output := (others => '0');
 rv.result_u24add_c_l34_c3_4e89_CLOCK_ENABLE := (others => '0');

    return rv;
  end function;


-- Type for this modules register pipeline
type register_pipeline_t is array(0 to PIPELINE_LATENCY) of variables_t;
  -- Each function instance gets signals
-- x[u24add_c_l34_c17_6950]
signal x_u24add_c_l34_c17_6950_return_output : unsigned(23 downto 0);

-- y[u24add_c_l34_c22_71c8]
signal y_u24add_c_l34_c22_71c8_return_output : unsigned(23 downto 0);

-- u24add[u24add_c_l34_c10_3def]
signal u24add_u24add_c_l34_c10_3def_x : unsigned(23 downto 0);
signal u24add_u24add_c_l34_c10_3def_y : unsigned(23 downto 0);
signal u24add_u24add_c_l34_c10_3def_return_output : unsigned(24 downto 0);

-- result[u24add_c_l34_c3_4e89]
signal result_u24add_c_l34_c3_4e89_CLOCK_ENABLE : unsigned(0 downto 0);
signal result_u24add_c_l34_c3_4e89_val : unsigned(24 downto 0);


begin

-- SUBMODULE INSTANCES 
-- x_u24add_c_l34_c17_6950
x_u24add_c_l34_c17_6950 : entity work.x_0CLK_23f04728 port map (
clk_cross_to_module.x_u24add_c_l34_c17_6950,
x_u24add_c_l34_c17_6950_return_output);

-- y_u24add_c_l34_c22_71c8
y_u24add_c_l34_c22_71c8 : entity work.y_0CLK_23f04728 port map (
clk_cross_to_module.y_u24add_c_l34_c22_71c8,
y_u24add_c_l34_c22_71c8_return_output);

-- u24add_u24add_c_l34_c10_3def
u24add_u24add_c_l34_c10_3def : entity work.u24add_0CLK_b45f1687 port map (
u24add_u24add_c_l34_c10_3def_x,
u24add_u24add_c_l34_c10_3def_y,
u24add_u24add_c_l34_c10_3def_return_output);

-- result_u24add_c_l34_c3_4e89
result_u24add_c_l34_c3_4e89 : entity work.result_0CLK_23f04728 port map (
result_u24add_c_l34_c3_4e89_CLOCK_ENABLE,
module_to_clk_cross.result_u24add_c_l34_c3_4e89,
result_u24add_c_l34_c3_4e89_val);



 -- Combinatorial process for pipeline stages
process (
 CLOCK_ENABLE,
 -- Clock cross input
 clk_cross_to_module,
 -- All submodule outputs
 -- x[u24add_c_l34_c17_6950]
 x_u24add_c_l34_c17_6950_return_output,
 -- y[u24add_c_l34_c22_71c8]
 y_u24add_c_l34_c22_71c8_return_output,
 -- u24add[u24add_c_l34_c10_3def]
 u24add_u24add_c_l34_c10_3def_return_output)
is 
 -- Read and write variables to do register transfers per clock
 -- from the previous to next stage
 variable read_pipe : variables_t;
 variable write_pipe : variables_t;

  -- This modules self pipeline registers read once per clock
  variable read_self_regs : register_pipeline_t;
  variable write_self_regs : register_pipeline_t;
begin
 -- Default null read_pipe
 -- NO DONT, hides tool problems? read_pipe := variables_NULL;
 -- Loop to construct simultaneous register transfers for each of the pipeline stages
 -- LATENCY=0 is combinational Logic
 for STAGE in 0 to PIPELINE_LATENCY loop
  -- Input to first stage are inputs to function
  if STAGE=0 then
   -- Mux in clock enable
   read_pipe.CLOCK_ENABLE := CLOCK_ENABLE;
  else
   -- Default read from previous stage
   read_pipe := read_self_regs(STAGE-1);
  end if;
  -- Default write contents of previous stage
  write_pipe := read_pipe;

   if STAGE = 0 then
   -- SUBMODULE LEVEL 0
   write_pipe.result_u24add_c_l34_c3_4e89_CLOCK_ENABLE := write_pipe.CLOCK_ENABLE;
   -- y[u24add_c_l34_c22_71c8] LATENCY=0
   -- Inputs
   -- Outputs
   write_pipe.y_u24add_c_l34_c22_71c8_return_output := y_u24add_c_l34_c22_71c8_return_output;

   -- x[u24add_c_l34_c17_6950] LATENCY=0
   -- Inputs
   -- Outputs
   write_pipe.x_u24add_c_l34_c17_6950_return_output := x_u24add_c_l34_c17_6950_return_output;

   -- SUBMODULE LEVEL 1
   write_pipe.u24add_u24add_c_l34_c10_3def_x := write_pipe.x_u24add_c_l34_c17_6950_return_output;
   write_pipe.u24add_u24add_c_l34_c10_3def_y := write_pipe.y_u24add_c_l34_c22_71c8_return_output;
   -- u24add[u24add_c_l34_c10_3def] LATENCY=0
   -- Inputs
   u24add_u24add_c_l34_c10_3def_x <= write_pipe.u24add_u24add_c_l34_c10_3def_x;
   u24add_u24add_c_l34_c10_3def_y <= write_pipe.u24add_u24add_c_l34_c10_3def_y;
   -- Outputs
   write_pipe.u24add_u24add_c_l34_c10_3def_return_output := u24add_u24add_c_l34_c10_3def_return_output;

   -- SUBMODULE LEVEL 2
   write_pipe.result_u24add_c_l34_c3_4e89_val := write_pipe.u24add_u24add_c_l34_c10_3def_return_output;
   -- result[u24add_c_l34_c3_4e89] LATENCY=0
   -- Clock enable
   result_u24add_c_l34_c3_4e89_CLOCK_ENABLE <= write_pipe.result_u24add_c_l34_c3_4e89_CLOCK_ENABLE;
   -- Inputs
   result_u24add_c_l34_c3_4e89_val <= write_pipe.result_u24add_c_l34_c3_4e89_val;
   -- Outputs

   end if;
  -- Write to stage reg
  write_self_regs(STAGE) := write_pipe;
  -- Some tools dont like if read_pipe is never fully driven, dummy drive
  -- And some tools dont like this dummy? read_pipe := write_pipe;
 end loop;


 -- Drive registers and outputs
end process;

end arch;
