-- Timing params:
--   Fixed?: False
--   Pipeline Slices: []
--   Input regs?: False
--   Output regs?: False
library std;
use std.textio.all;
library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use ieee.float_pkg.all;
use work.c_structs_pkg.all;
-- Submodules: 1
entity u24add_0CLK_b45f1687 is
port(
 x : in unsigned(23 downto 0);
 y : in unsigned(23 downto 0);
 return_output : out unsigned(24 downto 0));
end u24add_0CLK_b45f1687;
architecture arch of u24add_0CLK_b45f1687 is
-- Types and such
-- Declarations
constant PIPELINE_LATENCY : integer := 0;

-- One struct to represent this modules variables
type variables_t is record
 -- All of the wires in function
 BIN_OP_PLUS_u24add_c_l8_c10_9045_left : unsigned(23 downto 0);
 BIN_OP_PLUS_u24add_c_l8_c10_9045_return_output : unsigned(24 downto 0);
 BIN_OP_PLUS_u24add_c_l8_c10_9045_right : unsigned(23 downto 0);
 CLOCK_ENABLE : unsigned(0 downto 0);
 return_output : unsigned(24 downto 0);
 x : unsigned(23 downto 0);
 y : unsigned(23 downto 0);
end record;

-- Function to null out variables 
function variables_NULL return variables_t is
 variable rv : variables_t;
  begin
   rv.CLOCK_ENABLE := (others => '0');
 rv.return_output := (others => '0');
 rv.x := (others => '0');
 rv.y := (others => '0');
 rv.BIN_OP_PLUS_u24add_c_l8_c10_9045_left := (others => '0');
 rv.BIN_OP_PLUS_u24add_c_l8_c10_9045_right := (others => '0');
 rv.BIN_OP_PLUS_u24add_c_l8_c10_9045_return_output := (others => '0');

    return rv;
  end function;


-- Type for this modules register pipeline
type register_pipeline_t is array(0 to PIPELINE_LATENCY) of variables_t;
  -- Each function instance gets signals
-- BIN_OP_PLUS[u24add_c_l8_c10_9045]
signal BIN_OP_PLUS_u24add_c_l8_c10_9045_left : unsigned(23 downto 0);
signal BIN_OP_PLUS_u24add_c_l8_c10_9045_right : unsigned(23 downto 0);
signal BIN_OP_PLUS_u24add_c_l8_c10_9045_return_output : unsigned(24 downto 0);


begin

-- SUBMODULE INSTANCES 
-- BIN_OP_PLUS_u24add_c_l8_c10_9045
BIN_OP_PLUS_u24add_c_l8_c10_9045 : entity work.BIN_OP_PLUS_uint25_t_uint24_t_uint24_t_0CLK_de264c78 port map (
BIN_OP_PLUS_u24add_c_l8_c10_9045_left,
BIN_OP_PLUS_u24add_c_l8_c10_9045_right,
BIN_OP_PLUS_u24add_c_l8_c10_9045_return_output);



 -- Combinatorial process for pipeline stages
process (
 -- Inputs
 x,
 y,
 -- All submodule outputs
 -- BIN_OP_PLUS[u24add_c_l8_c10_9045]
 BIN_OP_PLUS_u24add_c_l8_c10_9045_return_output)
is 
 -- Read and write variables to do register transfers per clock
 -- from the previous to next stage
 variable read_pipe : variables_t;
 variable write_pipe : variables_t;

  -- This modules self pipeline registers read once per clock
  variable read_self_regs : register_pipeline_t;
  variable write_self_regs : register_pipeline_t;
begin
 -- Default null read_pipe
 -- NO DONT, hides tool problems? read_pipe := variables_NULL;
 -- Loop to construct simultaneous register transfers for each of the pipeline stages
 -- LATENCY=0 is combinational Logic
 for STAGE in 0 to PIPELINE_LATENCY loop
  -- Input to first stage are inputs to function
  if STAGE=0 then
   -- Mux in inputs
   read_pipe.x := x;
   read_pipe.y := y;
  else
   -- Default read from previous stage
   read_pipe := read_self_regs(STAGE-1);
  end if;
  -- Default write contents of previous stage
  write_pipe := read_pipe;

   if STAGE = 0 then
   -- SUBMODULE LEVEL 0
   write_pipe.BIN_OP_PLUS_u24add_c_l8_c10_9045_left := write_pipe.x;
   write_pipe.BIN_OP_PLUS_u24add_c_l8_c10_9045_right := write_pipe.y;
   -- BIN_OP_PLUS[u24add_c_l8_c10_9045] LATENCY=0
   -- Inputs
   BIN_OP_PLUS_u24add_c_l8_c10_9045_left <= write_pipe.BIN_OP_PLUS_u24add_c_l8_c10_9045_left;
   BIN_OP_PLUS_u24add_c_l8_c10_9045_right <= write_pipe.BIN_OP_PLUS_u24add_c_l8_c10_9045_right;
   -- Outputs
   write_pipe.BIN_OP_PLUS_u24add_c_l8_c10_9045_return_output := BIN_OP_PLUS_u24add_c_l8_c10_9045_return_output;

   -- SUBMODULE LEVEL 1
   write_pipe.return_output := write_pipe.BIN_OP_PLUS_u24add_c_l8_c10_9045_return_output;
   end if;
  -- Write to stage reg
  write_self_regs(STAGE) := write_pipe;
  -- Some tools dont like if read_pipe is never fully driven, dummy drive
  -- And some tools dont like this dummy? read_pipe := write_pipe;
 end loop;


 -- Drive registers and outputs
 -- Last stage of pipeline return wire to return port/reg
 return_output <= write_self_regs(PIPELINE_LATENCY).return_output;
end process;

end arch;
