-- Timing params:
--   Fixed?: False
--   Pipeline Slices: []
--   Input regs?: False
--   Output regs?: False
library std;
use std.textio.all;
library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use ieee.float_pkg.all;
use work.c_structs_pkg.all;
use work.clk_cross_t_pkg.all;
-- Submodules: 1
entity x_0CLK_23f04728 is
port(
 clk_cross_to_module : in x_clk_cross_to_module_t;
 return_output : out unsigned(23 downto 0));
end x_0CLK_23f04728;
architecture arch of x_0CLK_23f04728 is
-- Types and such
-- Declarations
constant PIPELINE_LATENCY : integer := 0;

-- One struct to represent this modules variables
type variables_t is record
 -- All of the wires in function
 CLOCK_ENABLE : unsigned(0 downto 0);
 CONST_REF_RD_uint24_t_uint24_t_array_1_t_data_0_d41d_u24add_c_l22_c283_40ef_return_output : unsigned(23 downto 0);
 return_output : unsigned(23 downto 0);
 rv : unsigned(23 downto 0);
 x_DEBUG_READ_u24add_c_l22_c262_90c0_return_output : uint24_t_array_1_t;
 x_DEBUG_clk_cross_read_array : uint24_t_array_1_t;
end record;

-- Function to null out variables 
function variables_NULL return variables_t is
 variable rv : variables_t;
  begin
   rv.CLOCK_ENABLE := (others => '0');
 rv.return_output := (others => '0');
 rv.rv := (others => '0');
 rv.x_DEBUG_clk_cross_read_array := uint24_t_array_1_t_NULL;
 rv.x_DEBUG_READ_u24add_c_l22_c262_90c0_return_output := uint24_t_array_1_t_NULL;
 rv.CONST_REF_RD_uint24_t_uint24_t_array_1_t_data_0_d41d_u24add_c_l22_c283_40ef_return_output := (others => '0');

    return rv;
  end function;


-- Type for this modules register pipeline
type register_pipeline_t is array(0 to PIPELINE_LATENCY) of variables_t;
  -- Each function instance gets signals

begin

-- SUBMODULE INSTANCES 


 -- Combinatorial process for pipeline stages
process (
 -- Clock cross input
 clk_cross_to_module)
is 
 -- Read and write variables to do register transfers per clock
 -- from the previous to next stage
 variable read_pipe : variables_t;
 variable write_pipe : variables_t;

  -- This modules self pipeline registers read once per clock
  variable read_self_regs : register_pipeline_t;
  variable write_self_regs : register_pipeline_t;
begin
 -- Default null read_pipe
 -- NO DONT, hides tool problems? read_pipe := variables_NULL;
 -- Loop to construct simultaneous register transfers for each of the pipeline stages
 -- LATENCY=0 is combinational Logic
 for STAGE in 0 to PIPELINE_LATENCY loop
  -- Input to first stage are inputs to function
  if STAGE=0 then
  else
   -- Default read from previous stage
   read_pipe := read_self_regs(STAGE-1);
  end if;
  -- Default write contents of previous stage
  write_pipe := read_pipe;

   if STAGE = 0 then
   -- SUBMODULE LEVEL 0
   -- x_DEBUG_READ[u24add_c_l22_c262_90c0] LATENCY=0
     -- Outputs
      write_pipe.x_DEBUG_READ_u24add_c_l22_c262_90c0_return_output := clk_cross_to_module.x_DEBUG_READ_return_output;

   -- SUBMODULE LEVEL 1
   -- CONST_REF_RD_uint24_t_uint24_t_array_1_t_data_0_d41d[u24add_c_l22_c283_40ef] LATENCY=0
   write_pipe.CONST_REF_RD_uint24_t_uint24_t_array_1_t_data_0_d41d_u24add_c_l22_c283_40ef_return_output := write_pipe.x_DEBUG_READ_u24add_c_l22_c262_90c0_return_output.data(0);

   -- SUBMODULE LEVEL 2
   write_pipe.return_output := write_pipe.CONST_REF_RD_uint24_t_uint24_t_array_1_t_data_0_d41d_u24add_c_l22_c283_40ef_return_output;
   end if;
  -- Write to stage reg
  write_self_regs(STAGE) := write_pipe;
  -- Some tools dont like if read_pipe is never fully driven, dummy drive
  -- And some tools dont like this dummy? read_pipe := write_pipe;
 end loop;


 -- Drive registers and outputs
 -- Last stage of pipeline return wire to return port/reg
 return_output <= write_self_regs(PIPELINE_LATENCY).return_output;
end process;

end arch;
