library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use work.c_structs_pkg.all;
use work.clk_cross_t_pkg.all;

  entity top_2a12 is
port(
clk_None : in std_logic;

-- IO for each main func
x_DEBUG_INPUT_MAIN_val : in unsigned(23 downto 0);
y_DEBUG_INPUT_MAIN_val : in unsigned(23 downto 0);
result_DEBUG_OUTPUT_MAIN_return_output : out unsigned(24 downto 0)
  );
end top_2a12;
architecture arch of top_2a12 is

-- Clock cross wires
signal clk_cross_to_module : clk_cross_to_module_t;
signal module_to_clk_cross : module_to_clk_cross_t;
signal clk_cross_y_DEBUG_return_output : uint24_t_array_1_t;
signal clk_cross_x_DEBUG_return_output : uint24_t_array_1_t;
signal clk_cross_result_DEBUG_return_output : uint25_t_array_1_t;
attribute syn_keep : boolean;
attribute keep : string;
attribute dont_touch : string;
signal x_DEBUG_INPUT_MAIN_0CLK_23f04728_val_input_reg : unsigned(23 downto 0) := (others => '0');
attribute syn_keep of x_DEBUG_INPUT_MAIN_0CLK_23f04728_val_input_reg : signal is true;
attribute keep of x_DEBUG_INPUT_MAIN_0CLK_23f04728_val_input_reg : signal is "true";
attribute dont_touch of x_DEBUG_INPUT_MAIN_0CLK_23f04728_val_input_reg : signal is "true";

signal y_DEBUG_INPUT_MAIN_0CLK_23f04728_val_input_reg : unsigned(23 downto 0) := (others => '0');
attribute syn_keep of y_DEBUG_INPUT_MAIN_0CLK_23f04728_val_input_reg : signal is true;
attribute keep of y_DEBUG_INPUT_MAIN_0CLK_23f04728_val_input_reg : signal is "true";
attribute dont_touch of y_DEBUG_INPUT_MAIN_0CLK_23f04728_val_input_reg : signal is "true";


signal result_DEBUG_OUTPUT_MAIN_return_output_output : unsigned(24 downto 0);
signal result_DEBUG_OUTPUT_MAIN_0CLK_23f04728_return_output_output_reg : unsigned(24 downto 0);
attribute syn_keep of result_DEBUG_OUTPUT_MAIN_0CLK_23f04728_return_output_output_reg : signal is true;
attribute keep of result_DEBUG_OUTPUT_MAIN_0CLK_23f04728_return_output_output_reg : signal is "true";
attribute dont_touch of result_DEBUG_OUTPUT_MAIN_0CLK_23f04728_return_output_output_reg : signal is "true";



begin

 -- IO regs
 process(clk_None) is
 begin
  if rising_edge(clk_None) then
   x_DEBUG_INPUT_MAIN_0CLK_23f04728_val_input_reg <= x_DEBUG_INPUT_MAIN_val;
  end if;
 end process;
 process(clk_None) is
 begin
  if rising_edge(clk_None) then
   y_DEBUG_INPUT_MAIN_0CLK_23f04728_val_input_reg <= y_DEBUG_INPUT_MAIN_val;
  end if;
 end process;
 process(clk_None) is
 begin
  if rising_edge(clk_None) then
   result_DEBUG_OUTPUT_MAIN_0CLK_23f04728_return_output_output_reg <= result_DEBUG_OUTPUT_MAIN_return_output_output;
  end if;
 end process;
 process(clk_None) is
 begin
  if rising_edge(clk_None) then
  end if;
 end process;
 result_DEBUG_OUTPUT_MAIN_return_output <= result_DEBUG_OUTPUT_MAIN_0CLK_23f04728_return_output_output_reg;

-- Instantiate each main
-- main functions always clock enabled
x_DEBUG_INPUT_MAIN_0CLK_23f04728 : entity work.x_DEBUG_INPUT_MAIN_0CLK_23f04728 port map (
to_unsigned(1,1),
module_to_clk_cross.x_DEBUG_INPUT_MAIN,
x_DEBUG_INPUT_MAIN_0CLK_23f04728_val_input_reg);

-- main functions always clock enabled
y_DEBUG_INPUT_MAIN_0CLK_23f04728 : entity work.y_DEBUG_INPUT_MAIN_0CLK_23f04728 port map (
to_unsigned(1,1),
module_to_clk_cross.y_DEBUG_INPUT_MAIN,
y_DEBUG_INPUT_MAIN_0CLK_23f04728_val_input_reg);

-- main functions always clock enabled
result_DEBUG_OUTPUT_MAIN_0CLK_23f04728 : entity work.result_DEBUG_OUTPUT_MAIN_0CLK_23f04728 port map (
clk_cross_to_module.result_DEBUG_OUTPUT_MAIN,
result_DEBUG_OUTPUT_MAIN_return_output_output);

-- main functions always clock enabled
test_bench_0CLK_f691aa4a : entity work.test_bench_0CLK_f691aa4a port map (
to_unsigned(1,1),
clk_cross_to_module.test_bench,
module_to_clk_cross.test_bench);


-- Instantiate each unidirectional data clock crossing
y_DEBUG : entity work.clk_cross_y_DEBUG port map
(
in_clk => clk_None,
in_clk_en => module_to_clk_cross.y_DEBUG_INPUT_MAIN.y_DEBUG_WRITE_CLOCK_ENABLE,
in_data => module_to_clk_cross.y_DEBUG_INPUT_MAIN.y_DEBUG_WRITE_in_data,
out_clk => clk_None,
rd_return_output => clk_cross_y_DEBUG_return_output
);
clk_cross_to_module.test_bench.y_u24add_c_l34_c22_71c8.y_DEBUG_READ_return_output <= clk_cross_y_DEBUG_return_output;

x_DEBUG : entity work.clk_cross_x_DEBUG port map
(
in_clk => clk_None,
in_clk_en => module_to_clk_cross.x_DEBUG_INPUT_MAIN.x_DEBUG_WRITE_CLOCK_ENABLE,
in_data => module_to_clk_cross.x_DEBUG_INPUT_MAIN.x_DEBUG_WRITE_in_data,
out_clk => clk_None,
rd_return_output => clk_cross_x_DEBUG_return_output
);
clk_cross_to_module.test_bench.x_u24add_c_l34_c17_6950.x_DEBUG_READ_return_output <= clk_cross_x_DEBUG_return_output;

result_DEBUG : entity work.clk_cross_result_DEBUG port map
(
in_clk => clk_None,
in_clk_en => module_to_clk_cross.test_bench.result_u24add_c_l34_c3_4e89.result_DEBUG_WRITE_CLOCK_ENABLE,
in_data => module_to_clk_cross.test_bench.result_u24add_c_l34_c3_4e89.result_DEBUG_WRITE_in_data,
out_clk => clk_None,
rd_return_output => clk_cross_result_DEBUG_return_output
);
clk_cross_to_module.result_DEBUG_OUTPUT_MAIN.result_DEBUG_READ_return_output <= clk_cross_result_DEBUG_return_output;


end arch;
